#!/bin/bash
#
# Last update: 2023.3.21
# ConfigServer Security & Firewall (csf) : http://www.configserver.com/cp/csf.html

# 安裝 csf
cd /usr/local/src/
wget https://download.configserver.com/csf.tgz
tar -xzf csf.tgz
cd csf
sh install.sh
cd ..
rm -rf csf*

# 調整 /etc/csf/csf.conf 設定
sed -i 's/^TESTING.=.*/TESTING = "0"/g' /etc/csf/csf.conf
sed -i 's/^TESTING_INTERVAL.=.*/TESTING_INTERVAL = "5"/g' /etc/csf/csf.conf
sed -i 's/^RESTRICT_SYSLOG_GROUP.*.=.*/RESTRICT_SYSLOG_GROUP\ =\ "mysyslog"/g' /etc/csf/csf.conf
sed -i 's/^RESTRICT_UI.*.=.*/RESTRICT_UI = "1"/g' /etc/csf/csf.conf
sed -i 's/^AUTO_UPDATES.*.=.*/AUTO_UPDATES = "1"/g' /etc/csf/csf.conf
sed -i 's/^LF_SPI.*.=.*/LF_SPI = "1"/g' /etc/csf/csf.conf
sed -i 's/^ICMP_IN\ =.*/ICMP_IN = "1"/g' /etc/csf/csf.conf
sed -i 's/^ICMP_IN_RATE.*.=.*/ICMP_IN_RATE\ =\ "6\/s"/g' /etc/csf/csf.conf
sed -i 's/^ICMP_OUT\ =.*/ICMP_OUT = "1"/g' /etc/csf/csf.conf
sed -i 's/^ICMP_OUT_RATE.*.=.*/ICMP_OUT_RATE = "0"/g' /etc/csf/csf.conf
sed -i 's/^IPV6_ICMP_STRICT.*.=.*/IPV6_ICMP_STRICT = "1"/g' /etc/csf/csf.conf
sed -i 's/^ICMP_TIMESTAMPDROP.*.=.*/ICMP_TIMESTAMPDROP = "1"/g' /etc/csf/csf.conf
sed -i 's/^IPV6_SPI.*.=.*/IPV6_SPI = "1"/g' /etc/csf/csf.conf
sed -i 's/^USE_CONNTRACK.*.=.*/USE_CONNTRACK = "0"/g' /etc/csf/csf.conf
sed -i 's/^USE_FTPHELPER.*.=.*/USE_FTPHELPER = "0"/g' /etc/csf/csf.conf
sed -i 's/^SYSLOG_CHECK.*.=.*/SYSLOG_CHECK = "1800"/g' /etc/csf/csf.conf
sed -i 's/^RELAYHOSTS.*.=.*/RELAYHOSTS = "1"/g' /etc/csf/csf.conf
sed -i 's/^IGNORE_ALLOW.*.=.*/IGNORE_ALLOW = "0"/g' /etc/csf/csf.conf
sed -i 's/^DNS_STRICT_NS\ =.*/DNS_STRICT_NS = "0"/g' /etc/csf/csf.conf
sed -i 's/^DENY_IP_LIMIT.=.*/DENY_IP_LIMIT = "300"/g' /etc/csf/csf.conf
sed -i 's/^LF_DAEMON.*.=.*/LF_DAEMON = "1"/g' /etc/csf/csf.conf
sed -i 's/^LF_CSF.*.=.*/LF_CSF = "1"/g' /etc/csf/csf.conf
sed -i 's/^FASTSTART.*.=.*/FASTSTART = "0"/g' /etc/csf/csf.conf
sed -i 's/^LF_IPSET\ =.*/LF_IPSET = "0"/g' /etc/csf/csf.conf
sed -i 's/^WAITLOCK\ =.*/WAITLOCK = "0"/g' /etc/csf/csf.conf
sed -i 's/^WAITLOCK_TIMEOUT.*.=.*/WAITLOCK_TIMEOUT = "300"/g' /etc/csf/csf.conf
sed -i 's/^LF_IPSET_HASHSIZE\ =.*/LF_IPSET_HASHSIZE = "1024"/g' /etc/csf/csf.conf
sed -i 's/^LF_IPSET_MAXELEM\ =.*/LF_IPSET_MAXELEM = "65536"/g' /etc/csf/csf.conf
sed -i 's/^LFDSTART.*.=.*/LFDSTART = "0"/g' /etc/csf/csf.conf
sed -i 's/^VERBOSE.*.=.*/VERBOSE = "0"/g' /etc/csf/csf.conf
sed -i 's/^PACKET_FILTER.*.=.*/PACKET_FILTER = "1"/g' /etc/csf/csf.conf
sed -i 's/^LF_LOOKUPS.*.=.*/LF_LOOKUPS = "1"/g' /etc/csf/csf.conf
sed -i 's/^STYLE_CUSTOM.*.=.*/STYLE_CUSTOM = "1"/g' /etc/csf/csf.conf
sed -i 's/^STYLE_MOBILE.*.=.*/STYLE_MOBILE = "1"/g' /etc/csf/csf.conf
sed -i 's/^SMTP_BLOCK.*.=.*/SMTP_BLOCK = "1"/g' /etc/csf/csf.conf
sed -i 's/^SMTP_ALLOWLOCAL.*.=.*/SMTP_ALLOWLOCAL = "1"/g' /etc/csf/csf.conf
sed -i 's/^SMTP_REDIRECT.*.=.*/SMTP_REDIRECT = "1"/g' /etc/csf/csf.conf
sed -i 's/^SMTPAUTH_RESTRICT.*.=.*/SMTPAUTH_RESTRICT = "0"/g' /etc/csf/csf.conf
sed -i 's/^SYNFLOOD\ =.*/SYNFLOOD = "0"/g' /etc/csf/csf.conf
sed -i 's/^SYNFLOOD_RATE\ =.*/SYNFLOOD_RATE = "100\/s"/g' /etc/csf/csf.conf
sed -i 's/^SYSLOG\ =.*/SYSLOG = "0"/g' /etc/csf/csf.conf
sed -i 's/^DROP\ =.*/DROP = "DROP"/g' /etc/csf/csf.conf
sed -i 's/^DROP_OUT\ =.*/DROP_OUT = "REJECT"/g' /etc/csf/csf.conf
sed -i 's/^PT_LOAD_LEVEL.*.=.*/PT_LOAD_LEVEL = "16"/g' /etc/csf/csf.conf
sed -i 's/^UI_SSL_VERSION.*.=.*/UI_SSL_VERSION = "SSLv23:!SSLv3:!SSLv2"/g' /etc/csf/csf.conf
sed -i 's/^GLOBAL_DYNDNS\ =.*/GLOBAL_DYNDNS = ""/g' /etc/csf/csf.conf
sed -i 's/^LF_DIRWATCH_DISABLE.*.=.*/LF_DIRWATCH_DISABLE = "1"/g' /etc/csf/csf.conf
sed -i 's/^LF_INTERVAL.*.=.*/LF_INTERVAL = "3600"/g' /etc/csf/csf.conf
sed -i 's/^PORTS_bind.*.=.*/PORTS_bind = "53;udp,53;tcp"/g' /etc/csf/csf.conf
sed -i 's/^LF_DIRWATCH_FILE.*.=.*/LF_DIRWATCH_FILE = "0"/g' /etc/csf/csf.conf
sed -i 's/^PT_LIMIT.*.=.*/PT_LIMIT = "0"/g' /etc/csf/csf.conf
sed -i 's/^PS_INTERVAL.*.=.*/PS_INTERVAL = "0"/g' /etc/csf/csf.conf
sed -i 's/^PT_USERPROC.*.=.*/PT_USERPROC = "0"/g' /etc/csf/csf.conf
sed -i 's/^PT_USERTIME.*.=.*/PT_USERTIME = "0"/g' /etc/csf/csf.conf
sed -i 's/^LF_GLOBAL.*.=.*/LF_GLOBAL = "3600"/g' /etc/csf/csf.conf
sed -i 's/^GLOBAL_ALLOW.*.=.*/GLOBAL_ALLOW = "https:\/\/data.yji.tw\/csf\/glob_allow.rules"/g' /etc/csf/csf.conf
sed -i 's/^GLOBAL_DENY.*.=.*/GLOBAL_DENY = "https:\/\/data.yji.tw\/csf\/glob_deny.rules"/g' /etc/csf/csf.conf
#sed -i 's/^GLOBAL_ALLOW.*.=.*/GLOBAL_ALLOW = "http:\/\/g-host.net\/gay\/apf\/glob_allow.rules"/g' /etc/csf/csf.conf
#sed -i 's/^GLOBAL_DENY.*.=.*/GLOBAL_DENY = "http:\/\/g-host.net\/gay\/apf\/glob_deny.rules"/g' /etc/csf/csf.conf

# 2023/7/20 Jacky Checking
sed -i 's/^LF_SSH_EMAIL_ALERT.*.=.*/LF_SSH_EMAIL_ALERT = "1"/g' /etc/csf/csf.conf
sed -i 's/^LF_SU_EMAIL_ALERT.*.=.*/LF_SU_EMAIL_ALERT = "1"/g' /etc/csf/csf.conf
sed -i 's/^PS_EMAIL_ALERT.*.=.*/PS_EMAIL_ALERT = "1"/g' /etc/csf/csf.conf
sed -i 's/^LF_SUDO_EMAIL_ALERT.*.=.*/LF_SUDO_EMAIL_ALERT = "0"/g' /etc/csf/csf.conf
sed -i 's/^LF_EMAIL_ALERT.*.=.*/LF_EMAIL_ALERT = "0"/g' /etc/csf/csf.conf
sed -i 's/^LF_TEMP_EMAIL_ALERT.*.=.*/LF_TEMP_EMAIL_ALERT = "1"/g' /etc/csf/csf.conf
sed -i 's/^CT_EMAIL_ALERT.*.=.*/CT_EMAIL_ALERT = "1"/g' /etc/csf/csf.conf

sed -i 's/^LF_SCRIPT_ALERT.=.*/LF_SCRIPT_ALERT = "0"/g' /etc/csf/csf.conf
sed -i 's/^TCP_IN.=.*/TCP_IN = "20,21,25,53,80,110,143,443,465,587,993,995,2077,2078,2082,2083,2086,2087,2095,2096,30000:50000"/g' /etc/csf/csf.conf
sed -i 's/^TCP_OUT.=.*/TCP_OUT = "20,21,22,37,43,53,80,110,113,443,873,993,995,2086,2087,2089,2703"/g' /etc/csf/csf.conf
sed -i 's/^TCP6_IN.=.*/TCP6_IN = "20,21,25,53,80,110,143,443,465,587,993,995,2077,2078,2082,2083,2086,2087,2095,2096,30000:50000"/g' /etc/csf/csf.conf
sed -i 's/^TCP6_OUT.=.*/TCP6_OUT = "20,21,22,37,43,53,80,110,113,443,873,993,995,2086,2087,2089,2703"/g' /etc/csf/csf.conf
sed -i 's/^UDP_IN.=.*/UDP_IN = "20,21,53"/g' /etc/csf/csf.conf
sed -i 's/^UDP_OUT.=.*/UDP_OUT = "20,21,53,113,123,514,873,6277,33434:33523"/g' /etc/csf/csf.conf
sed -i 's/^UDP6_IN.=.*/UDP6_IN = "20,21,53"/g' /etc/csf/csf.conf
sed -i 's/^UDP6_OUT.=.*/UDP6_OUT = "20,21,53,113,123,514,873,6277,33434:33523"/g' /etc/csf/csf.conf
sed -i 's/^LF_DIRWATCH.=.*/LF_DIRWATCH = "0"/g' /etc/csf/csf.conf
sed -i 's/^CC_LOOKUPS.=.*/CC_LOOKUPS = "0"/g' /etc/csf/csf.conf
sed -i 's/^MESSENGER_HTTPS_IN.=.*/MESSENGER_HTTPS_IN = "443,2083,2096"/g' /etc/csf/csf.conf
sed -i 's/^MESSENGER_HTML.=.*/MESSENGER_HTML = "9000"/g' /etc/csf/csf.conf
sed -i 's/^MESSENGER_RATE.=.*/MESSENGER_RATE = "30\/m"/g' /etc/csf/csf.conf

# NAS
# sed -i 's/^TCP_IN.=.*/TCP_IN = "20,21,80,873"/g' /etc/csf/csf.conf
# sed -i 's/^TCP_OUT.=.*/TCP_OUT = "22,25,53,80,443,5666"/g' /etc/csf/csf.conf
# sed -i 's/^TCP6_IN.=.*/TCP6_IN = "20,21,80,873"/g' /etc/csf/csf.conf
# sed -i 's/^TCP6_OUT.=.*/TCP6_OUT = "22,25,53,80,443,5666"/g' /etc/csf/csf.conf
# sed -i 's/^UDP_IN.=.*/UDP_IN = "20,21,53"/g' /etc/csf/csf.conf
# sed -i 's/^UDP_OUT.=.*/UDP_OUT = "20,21,53,123,33434:33523"/g' /etc/csf/csf.conf
# sed -i 's/^UDP6_IN.=.*/UDP6_IN = "20,21,53"/g' /etc/csf/csf.conf
# sed -i 's/^UDP6_OUT.=.*/UDP6_OUT = "20,21,53,123,33434:33523"/g' /etc/csf/csf.conf

# https://forum.configserver.com/viewtopic.php?t=10725
sed -i 's/^CC_OLDGEOLITE.=.*/CC_OLDGEOLITE = "0"/g' /etc/csf/csf.conf

sed -i 's/^RESTRICT_SYSLOG.=.*/RESTRICT_SYSLOG = "3"/g' /etc/csf/csf.conf
sed -i 's/^LF_SMTPAUTH.=.*/LF_SMTPAUTH = "12"/g' /etc/csf/csf.conf
sed -i 's/^LF_HTACCESS.=.*/LF_HTACCESS = "7"/g' /etc/csf/csf.conf
sed -i 's/^LF_CPANEL.=.*/LF_CPANEL = "10"/g' /etc/csf/csf.conf
sed -i 's/^LF_MODSEC.=.*/LF_MODSEC = "0"/g' /etc/csf/csf.conf
sed -i 's/^LT_POP3D.=.*/LT_POP3D = "0"/g' /etc/csf/csf.conf
sed -i 's/^MESSENGER.=.*/MESSENGER = "1"/g' /etc/csf/csf.conf
sed -i 's/^PT_ALL_USERS.=.*/PT_ALL_USERS = "1"/g' /etc/csf/csf.conf
sed -i 's/^SAFECHAINUPDATE.=.*/SAFECHAINUPDATE = "1"/g' /etc/csf/csf.conf

# Disable System Integrity Checking
sed -i 's/^LF_INTEGRITY.*.=.*/LF_INTEGRITY = "0"/g' /etc/csf/csf.conf

# 修正PHP程式使用FTP被動市模式Port會亂跳的問題
sed -i 's/^USE_FTPHELPER.*.=.*/USE_FTPHELPER = "21"/g' /etc/csf/csf.conf

# Disable PT_USERPROC and PT_USERMEM
if [ -e /usr/sbin/cagefsctl ]; then
sed -i 's/^PT_USERPROC.=.*/PT_USERPROC = "0"/g' /etc/csf/csf.conf
sed -i 's/^PT_USERMEM.=.*/PT_USERMEM = "0"/g' /etc/csf/csf.conf
fi

# 設定 /etc/csf/csf.pignore
echo 'exe:/opt/memcached/bin/memcached' >> /etc/csf/csf.pignore
if [ -e /usr/local/openresty/nginx/sbin/nginx ]; then
echo 'exe:/usr/local/openresty/nginx/sbin/nginx' >> /etc/csf/csf.pignore
fi

# 新增 csf messenger
useradd csf -s /bin/false
rm -f /etc/csf/messenger/index.html
rm -f /etc/csf/messenger/index.text
cp /opt/cpinst/cpinst/config/csf_index.html /etc/csf/messenger/index.html
cp /opt/cpinst/cpinst/config/csf_index.text /etc/csf/messenger/index.text


# 自用主機 特別設定
if [ $1 == "1" ]; then

    # 判斷自用主機 加入CT 連線次數限制
    sed -i 's/^CT_LIMIT.=.*/CT_LIMIT = "500"/g' /etc/csf/csf.conf
    sed -i 's/^CT_PORTS.=.*/CT_PORTS = "80,443"/g' /etc/csf/csf.conf
    sed -i 's/^CT_PERMANENT.=.*/CT_PERMANENT = "0"/g' /etc/csf/csf.conf

    # 自製RBL list [Adwin]
    # https://abuse.kltw.mickey.tw/
    echo '# Yuan-Jhen AbuseIP List' >> /etc/csf/csf.blocklists
    echo 'YJABUSE|7200|0|https://abuse.kltw.mickey.tw/api/get.php?subnet' >> /etc/csf/csf.blocklists
    sed -i 's/^LF_IPSET.=.*/LF_IPSET = "1"/g' /etc/csf/csf.conf
    csf -r

    # 自製 Suspend Page
    mkdir -p /var/cpanel/webtemplates/root/english/
    cp /opt/cpinst/cpinst/config/suspended.tmpl /var/cpanel/webtemplates/root/english/
    cp /opt/cpinst/cpinst/config/moving.tmpl /var/cpanel/webtemplates/root/english/

    # CSF 一小時內寄送不存在信箱超過十次則封鎖IP
    cat /opt/cpinst/cpinst/config/regex.custom.pm > /etc/csf/regex.custom.pm
    sed -i 's/^CUSTOM1_LOG.=.*/CUSTOM1_LOG = "\/var\/log\/exim_mainlog"/g' /etc/csf/csf.conf
    csf -ra

fi

# 客戶主機 特別設定
if [ $1 == "2" ]; then

   # 客戶用改成另外一組 CSF GLOBAL ALLOW & DENY
   sed -i 's/^GLOBAL_ALLOW.*.=.*/GLOBAL_ALLOW = "https:\/\/data.yji.tw\/csf\/glob_allow_ma.rules"/g' /etc/csf/csf.conf
   csf -ra

fi

# Yuanjhen Office NCIC & Hinet internet
echo '210.59.165.80' >> /etc/csf/csf.ignore
echo '122.146.90.137' >> /etc/csf/csf.ignore
echo '103.129.169.0/25' >> /etc/csf/csf.ignore
echo '103.129.169.60' >> /etc/csf/csf.ignore
echo '103.129.169.61' >> /etc/csf/csf.ignore
echo '103.129.169.62' >> /etc/csf/csf.ignore

# 重啟 csf
csf -ra

